diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-mac.cc ns-3.39/src/lr-wpan/model/lr-wpan-mac.cc
--- ns-3.38/src/lr-wpan/model/lr-wpan-mac.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-mac.cc	2023-07-05 14:23:47.869427400 -0700
@@ -2834,8 +3114,38 @@
             }
             else if (macHdr.IsCommand())
             {
-                // We handle commands that do not require ACK (e.g. BeaconReq command)
-                // other command are handle by the previous if statement.
+                // We handle commands that do not require ACK
+                // (e.g. Coordinator realigment command in an orphan response)
+                // Other command with ACK required are handle by the previous if statement.
+
+                // Check the transmitted packet command type and issue the appropriate indication.
+                Ptr<Packet> txOriginalPkt = m_txPkt->Copy();
+                LrWpanMacHeader txMacHdr;
+                txOriginalPkt->RemoveHeader(txMacHdr);
+                CommandPayloadHeader txMacPayload;
+                txOriginalPkt->RemoveHeader(txMacPayload);
+
+                if (txMacPayload.GetCommandFrameType() == CommandPayloadHeader::COOR_REALIGN)
+                {
+                    if (!m_mlmeCommStatusIndicationCallback.IsNull())
+                    {
+                        MlmeCommStatusIndicationParams commStatusParams;
+                        commStatusParams.m_panId = m_macPanId;
+
+                        commStatusParams.m_srcAddrMode = macHdr.GetSrcAddrMode();
+                        commStatusParams.m_srcExtAddr = macHdr.GetExtSrcAddr();
+                        commStatusParams.m_srcShortAddr = macHdr.GetShortSrcAddr();
+
+                        commStatusParams.m_dstAddrMode = macHdr.GetDstAddrMode();
+                        commStatusParams.m_dstExtAddr = macHdr.GetExtDstAddr();
+                        commStatusParams.m_dstShortAddr = macHdr.GetShortDstAddr();
+
+                        commStatusParams.m_status = LrWpanMlmeCommStatus::MLMECOMMSTATUS_SUCCESS;
+                        m_mlmeCommStatusIndicationCallback(commStatusParams);
+                    }
+                }
+
+                ifsWaitTime = Seconds(static_cast<double>(GetIfsSize()) / symbolRate);
                 RemoveFirstTxQElement();
             }
             else
@@ -3012,7 +3322,7 @@
 void
 LrWpanMac::PlmeGetAttributeConfirm(LrWpanPhyEnumeration status,
                                    LrWpanPibAttributeIdentifier id,
-                                   LrWpanPhyPibAttributes* attribute)
+                                   Ptr<LrWpanPhyPibAttributes> attribute)
 {
     NS_LOG_FUNCTION(this << status << id << attribute);
 }
@@ -3090,10 +3400,10 @@
 
             if (channelFound)
             {
-                LrWpanPhyPibAttributes pibAttr;
-                pibAttr.phyCurrentChannel = m_channelScanIndex;
+                Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+                pibAttr->phyCurrentChannel = m_channelScanIndex;
                 m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel,
-                                               &pibAttr);
+                                               pibAttr);
             }
         }
         else
@@ -3115,9 +3425,19 @@
         if (status == LrWpanPhyEnumeration::IEEE_802_15_4_PHY_SUCCESS)
         {
             uint64_t symbolRate = static_cast<uint64_t>(m_phy->GetDataOrSymbolRate(false));
-            uint64_t scanDuration = lrwpan::aBaseSuperframeDuration *
-                                    ((static_cast<uint32_t>(1 << m_scanParams.m_scanDuration)) + 1);
-            Time nextScanTime = Seconds(static_cast<double>(scanDuration / symbolRate));
+            Time nextScanTime;
+
+            if (m_scanParams.m_scanType == MLMESCAN_ORPHAN)
+            {
+                nextScanTime = Seconds(static_cast<double>(m_macResponseWaitTime) / symbolRate);
+            }
+            else
+            {
+                uint64_t scanDurationSym =
+                    lrwpan::aBaseSuperframeDuration * (pow(2, m_scanParams.m_scanDuration) + 1);
+
+                nextScanTime = Seconds(static_cast<double>(scanDurationSym) / symbolRate);
+            }
 
             switch (m_scanParams.m_scanType)
             {
@@ -3138,8 +3458,9 @@
                 m_phy->PlmeSetTRXStateRequest(IEEE_802_15_4_PHY_RX_ON);
                 break;
             case MLMESCAN_ORPHAN:
-                // TODO: add orphan scan support
-                NS_LOG_ERROR("Scan Type currently not supported");
+                m_scanOrphanEvent =
+                    Simulator::Schedule(nextScanTime, &LrWpanMac::EndChannelScan, this);
+                SendOrphanNotificationCommand();
                 break;
 
             default:
@@ -3174,10 +3495,10 @@
     {
         if (status == LrWpanPhyEnumeration::IEEE_802_15_4_PHY_SUCCESS)
         {
-            LrWpanPhyPibAttributes pibAttr;
-            pibAttr.phyCurrentChannel = m_startParams.m_logCh;
+            Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+            pibAttr->phyCurrentChannel = m_startParams.m_logCh;
             m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel,
-                                           &pibAttr);
+                                           pibAttr);
         }
         else
         {
@@ -3213,10 +3534,10 @@
     {
         if (status == LrWpanPhyEnumeration::IEEE_802_15_4_PHY_SUCCESS)
         {
-            LrWpanPhyPibAttributes pibAttr;
-            pibAttr.phyCurrentChannel = m_associateParams.m_chNum;
+            Ptr<LrWpanPhyPibAttributes> pibAttr = Create<LrWpanPhyPibAttributes>();
+            pibAttr->phyCurrentChannel = m_associateParams.m_chNum;
             m_phy->PlmeSetAttributeRequest(LrWpanPibAttributeIdentifier::phyCurrentChannel,
-                                           &pibAttr);
+                                           pibAttr);
         }
         else
         {
@@ -3378,8 +3699,41 @@
                 }
                 break;
             }
+            case CommandPayloadHeader::COOR_REALIGN: {
+                if (!m_mlmeCommStatusIndicationCallback.IsNull())
+                {
+                    MlmeCommStatusIndicationParams commStatusParams;
+                    commStatusParams.m_panId = m_macPanId;
+                    commStatusParams.m_srcAddrMode = LrWpanMacHeader::EXTADDR;
+                    commStatusParams.m_srcExtAddr = macHdr.GetExtSrcAddr();
+                    commStatusParams.m_dstAddrMode = LrWpanMacHeader::EXTADDR;
+                    commStatusParams.m_dstExtAddr = macHdr.GetExtDstAddr();
+                    commStatusParams.m_status =
+                        LrWpanMlmeCommStatus::MLMECOMMSTATUS_CHANNEL_ACCESS_FAILURE;
+                    m_mlmeCommStatusIndicationCallback(commStatusParams);
+                }
+                break;
+            }
+            case CommandPayloadHeader::ORPHAN_NOTIF: {
+                if (m_scanOrphanEvent.IsRunning())
+                {
+                    m_unscannedChannels.emplace_back(m_phy->GetCurrentChannelNum());
+                }
+                // TODO: Handle orphan notification command during a
+                //       channel access failure when not is not scanning.
+                break;
+            }
+            case CommandPayloadHeader::BEACON_REQ: {
+                if (m_scanEvent.IsRunning())
+                {
+                    m_unscannedChannels.emplace_back(m_phy->GetCurrentChannelNum());
+                }
+                // TODO: Handle beacon request command during a
+                //       channel access failure when not scanning.
+                break;
+            }
             default: {
-                // TODO: Other commands(e.g. Orphan Request)
+                // TODO: Other commands(e.g. Disassociation notification, etc)
                 break;
             }
             }
@@ -3517,9 +3871,9 @@
     LrWpanMacHeader macHdr;
     m_txPkt->PeekHeader(macHdr);
 
-    if (m_panCoor)
+    if (m_coor)
     {
-        // The device is the PAN coordinator and the packet is not to itself
+        // The device is its coordinator and the packet is not to itself
         return false;
     }
     else if (m_macCoordShortAddress == macHdr.GetShortDstAddr() ||
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-mac.h ns-3.39/src/lr-wpan/model/lr-wpan-mac.h
--- ns-3.38/src/lr-wpan/model/lr-wpan-mac.h	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-mac.h	2023-07-05 14:23:47.869427400 -0700
@@ -326,13 +326,28 @@
 /**
  * \ingroup lr-wpan
  *
+ * Table 20 of IEEE 802.15.4-2011
+ */
+enum LrWpanMlmeGetConfirmStatus
+{
+    MLMEGET_SUCCESS = 0,
+    MLMEGET_UNSUPPORTED_ATTRIBUTE = 1
+};
+
+/**
+ * \ingroup lr-wpan
+ *
  * IEEE802.15.4-2011 MAC PIB Attribute Identifiers Table 52 in section 6.4.2
  *
  */
 enum LrWpanMacPibAttributeIdentifier
 {
     macBeaconPayload = 0,
-    macBeaconPayloadLength = 1
+    macBeaconPayloadLength = 1,
+    macShortAddress = 2,
+    macExtendedAddress = 3,
+    macPanId = 4,
+    unsupported = 255
     // TODO: complete other MAC pib attributes
 };
 
@@ -345,6 +360,9 @@
 {
     Ptr<Packet> macBeaconPayload;      //!< The contents of the beacon payload.
     uint8_t macBeaconPayloadLength{0}; //!< The length in octets of the beacon payload.
+    Mac16Address macShortAddress;      //!< The 16 bit mac short address
+    Mac64Address macExtendedAddress;   //!< The EUI-64 bit address
+    uint16_t macPanId;                 //!< The identifier of the PAN
     // TODO: complete other MAC pib attributes
 };
 
@@ -455,11 +473,11 @@
  */
 struct MlmeStartRequestParams
 {
-    uint16_t m_PanId{0}; //!< Pan Identifier used by the device.
-    uint8_t m_logCh{
-        11}; //!< Logical channel on which to start using the new superframe configuration.
-    uint32_t m_logChPage{
-        0}; //!< Logical channel page on which to start using the new superframe configuration.
+    uint16_t m_PanId{0};     //!< Pan Identifier used by the device.
+    uint8_t m_logCh{11};     //!< Logical channel on which to start using the
+                             //!< new superframe configuration.
+    uint32_t m_logChPage{0}; //!< Logical channel page on which to start using the
+                             //!< new superframe configuration.
     uint32_t m_startTime{0}; //!< Time at which to begin transmitting beacons (Used by Coordinator
                              //!< not PAN Coordinators). The time is specified in symbols.
     uint8_t m_bcnOrd{15};    //!< Beacon Order, Used to calculate the beacon interval, a value of 15
@@ -507,9 +525,13 @@
 {
     LrWpanMlmeScanType m_scanType{MLMESCAN_PASSIVE}; //!< Indicates the type of scan performed as
                                                      //!< described in IEEE 802.15.4-2011 (5.1.2.1).
-    uint32_t m_scanChannels{0x7FFFFFF};              //!< The channel numbers to be scanned.
-    uint8_t m_scanDuration{14}; //!< A value used to calculate the length of time to spend scanning
-                                //!< [aBaseSuperframeDuration * (2^m_scanDuration +)].
+    uint32_t m_scanChannels{0x7FFF800};              //!< The channel numbers to be scanned.
+                                                     //!< Default: (0x7FFF800 = Ch11-Ch26)
+                                                     //!< 27 LSB (b0,b1,...,b26) = channels
+    uint8_t m_scanDuration{14}; //!< The factor (0-14) used to calculate the length of time
+                                //!< to spend scanning.
+                                //!< scanDurationSymbols =
+                                //!< [aBaseSuperframeDuration * (2^m_scanDuration + 1)].
     uint32_t m_chPage{0};       //!< The channel page on which to perform scan.
 };
 
@@ -520,16 +542,17 @@
  */
 struct MlmeScanConfirmParams
 {
-    LrWpanMlmeScanConfirmStatus m_status{
-        MLMESCAN_INVALID_PARAMETER}; //!< The status of the scan request.
-    LrWpanMlmeScanType m_scanType{
-        MLMESCAN_PASSIVE}; //!< Indicates the type of scan performed (ED,ACTIVE,PASSIVE,ORPHAN).
-    uint32_t m_chPage{0};  //!< The channel page on which the scan was performed.
-    std::vector<uint8_t> m_unscannedCh; //!< A list of channels given in the request which were not
-                                        //!< scanned (Not valid for ED scans).
-    std::vector<uint8_t>
-        m_energyDetList; //!< A list of energy measurements, one for each channel searched during ED
-                         //!< scan (Not valid for Active, Passive or Orphan Scans)
+    LrWpanMlmeScanConfirmStatus m_status{MLMESCAN_INVALID_PARAMETER}; //!< The status the request.
+    LrWpanMlmeScanType m_scanType{MLMESCAN_PASSIVE}; //!< Indicates the type of scan
+                                                     //!<  performed (ED,ACTIVE,PASSIVE,ORPHAN).
+    uint32_t m_chPage{0};                 //!< The channel page on which the scan was performed.
+    std::vector<uint8_t> m_unscannedCh;   //!< A list of channels given in the request which
+                                          //!<  were not scanned (Not valid for ED scans).
+    uint8_t m_resultListSize{0};          //!< The number of elements returned in the appropriate
+                                          //!<  result list. (Not valid for Orphan scan).
+    std::vector<uint8_t> m_energyDetList; //!< A list of energy measurements, one for each
+                                          //!< channel searched during ED scan
+                                          //!< (Not valid for Active, Passive or Orphan Scans)
     std::vector<PanDescriptor> m_panDescList; //!< A list of PAN descriptor, one for each beacon
                                               //!< found (Not valid for ED and Orphan scans).
 };
@@ -620,16 +643,38 @@
     Mac64Address m_srcExtAddr; //!< The extended address of the entity from which the frame causing
                                //!< the error originated.
     uint8_t m_dstAddrMode{SHORT_ADDR}; //!< The destination addressing mode for this primitive.
-    Mac16Address
-        m_dstShortAddr; //!< The short address of the device for which the frame was intended.
-    Mac64Address
-        m_dstExtAddr; //!< The extended address of the device for which the frame was intended.
+    Mac16Address m_dstShortAddr;       //!< The short address of the device for
+                                       //!< which the frame was intended.
+    Mac64Address m_dstExtAddr;         //!< The extended address of the device for
+                                       //!< which the frame was intended.
     LrWpanMlmeCommStatus m_status{MLMECOMMSTATUS_INVALID_PARAMETER}; //!< The communication status
 };
 
 /**
  * \ingroup lr-wpan
  *
+ * MLME-ORPHAN.indication params. See  802.15.4-2011   Section 6.2.7.1
+ */
+struct MlmeOrphanIndicationParams
+{
+    Mac64Address m_orphanAddr; //!< The address of the orphaned device.
+};
+
+/**
+ * \ingroup lr-wpan
+ *
+ * MLME-ORPHAN.response params. See  802.15.4-2011   Section 6.2.7.2
+ */
+struct MlmeOrphanResponseParams
+{
+    Mac64Address m_orphanAddr; //!< The address of the orphaned device.
+    Mac16Address m_shortAddr;  //!< The short address allocated.
+    bool m_assocMember{false}; //!< T = allocated with this coord |  F = otherwise
+};
+
+/**
+ * \ingroup lr-wpan
+ *
  * MLME-START.confirm params. See  802.15.4-2011   Section 6.2.14.2
  */
 struct MlmePollConfirmParams
@@ -646,9 +691,9 @@
  */
 struct MlmeSetConfirmParams
 {
-    LrWpanMlmeSetConfirmStatus m_status{
-        MLMESET_UNSUPPORTED_ATTRIBUTE}; //!< The result of the request to write
-                                        //!< the PIB attribute.
+    LrWpanMlmeSetConfirmStatus m_status{MLMESET_UNSUPPORTED_ATTRIBUTE}; //!< The result of
+                                                                        //!< the request to write
+                                                                        //!< the PIB attribute.
     LrWpanMacPibAttributeIdentifier id; //!< The id of the PIB attribute that was written.
 };
 
@@ -754,6 +799,17 @@
 /**
  * \ingroup lr-wpan
  *
+ * This callback is called by the MLME and issued to its next higher layer following
+ * the reception of a orphan notification.
+ *
+ *  Security related parameters and not handle.
+ *  See 802.15.4-2011 6.2.7.1
+ */
+typedef Callback<void, MlmeOrphanIndicationParams> MlmeOrphanIndicationCallback;
+
+/**
+ * \ingroup lr-wpan
+ *
  * This callback is called after a MlmeSetRequest has been called from
  * the higher layer to set a PIB. It returns a status of the outcome of the
  * write attempt.
@@ -763,6 +819,19 @@
 /**
  * \ingroup lr-wpan
  *
+ * This callback is called after a MlmeGetRequest has been called from
+ * the higher layer to get a PIB. It returns a status of the outcome of the
+ * write attempt.
+ */
+typedef Callback<void,
+                 LrWpanMlmeGetConfirmStatus,
+                 LrWpanMacPibAttributeIdentifier,
+                 Ptr<LrWpanMacPibAttributes>>
+    MlmeGetConfirmCallback;
+
+/**
+ * \ingroup lr-wpan
+ *
  * Class that implements the LR-WPAN MAC state machine
  */
 class LrWpanMac : public Object
@@ -902,6 +971,16 @@
     void MlmeAssociateResponse(MlmeAssociateResponseParams params);
 
     /**
+     * IEEE 802.15.4-2011, section 6.2.7.2
+     * MLME-ORPHAN.response
+     * Primitive used to initiatte a response to an MLME-ORPHAN.indication
+     * primitive.
+     *
+     * \param params the orphan response parameters
+     */
+    void MlmeOrphanResponse(MlmeOrphanResponseParams params);
+
+    /**
      * IEEE 802.15.4-2011, section 6.2.13.1
      * MLME-SYNC.request
      * Request to synchronize with the coordinator by acquiring and,
@@ -931,6 +1010,15 @@
     void MlmeSetRequest(LrWpanMacPibAttributeIdentifier id, Ptr<LrWpanMacPibAttributes> attribute);
 
     /**
+     * IEEE 802.15.4-2011, section 6.2.5.1
+     * MLME-GET.request
+     * Request information about a given PIB attribute.
+     *
+     * \param id the attribute identifier
+     */
+    void MlmeGetRequest(LrWpanMacPibAttributeIdentifier id);
+
+    /**
      * Set the CSMA/CA implementation to be used by the MAC.
      *
      * \param csmaCa the CSMA/CA implementation
@@ -979,6 +1067,15 @@
     void SetMlmeCommStatusIndicationCallback(MlmeCommStatusIndicationCallback c);
 
     /**
+     * Set the callback for the indication to the reception of an orphan notification.
+     * The callback implements MLME-ORPHAN.indication SAP of IEEE 802.15.4-2011,
+     * section 6.2.7.1.
+     *
+     * \param c the callback
+     */
+    void SetMlmeOrphanIndicationCallback(MlmeOrphanIndicationCallback c);
+
+    /**
      * Set the callback for the confirmation of a data transmission request.
      * The callback implements MCPS-DATA.confirm SAP of IEEE 802.15.4-2006,
      * section 7.1.1.2.
@@ -1050,6 +1147,15 @@
      */
     void SetMlmeSetConfirmCallback(MlmeSetConfirmCallback c);
 
+    /**
+     * Set the callback for the confirmation of an attempt to read an attribute.
+     * The callback implements MLME-GET.confirm SAP of IEEE 802.15.4-2011,
+     * section 6.2.5.2
+     *
+     *\param c the callback
+     */
+    void SetMlmeGetConfirmCallback(MlmeGetConfirmCallback c);
+
     // interfaces between MAC and PHY
 
     /**
@@ -1095,7 +1201,7 @@
      */
     void PlmeGetAttributeConfirm(LrWpanPhyEnumeration status,
                                  LrWpanPibAttributeIdentifier id,
-                                 LrWpanPhyPibAttributes* attribute);
+                                 Ptr<LrWpanPhyPibAttributes> attribute);
 
     /**
      * IEEE 802.15.4-2006 section 6.2.2.8
@@ -1363,6 +1469,11 @@
     bool m_panCoor;
 
     /**
+     * Indicates if the current device is a coordinator type
+     */
+    bool m_coor;
+
+    /**
      * Indication of the Interval used by the coordinator to transmit beacon frames
      * expressed in symbols.
      */
@@ -1564,6 +1675,13 @@
     void SendBeaconRequestCommand();
 
     /**
+     * Called to send a orphan notification command. This is used by an associated device that
+     * has lost synchronization with its coordinator.
+     * As described in IEEE 802.15.4-2011 (Section 5.3.6)
+     */
+    void SendOrphanNotificationCommand();
+
+    /**
      * Called to end a MLME-START.request after changing the page and channel number.
      */
     void EndStartRequest();
@@ -1903,6 +2021,13 @@
     MlmeSetConfirmCallback m_mlmeSetConfirmCallback;
 
     /**
+     * This callback is used to report the result of an attribute read request
+     * to the upper layers.
+     * See IEEE 802.15.4-2011, section 6.2.5.2
+     */
+    MlmeGetConfirmCallback m_mlmeGetConfirmCallback;
+
+    /**
      * This callback is used to notify incoming beacon packets to the upper layers.
      * See IEEE 802.15.4-2011, section 6.2.4.1.
      */
@@ -1961,6 +2086,12 @@
     MlmeCommStatusIndicationCallback m_mlmeCommStatusIndicationCallback;
 
     /**
+     * This callback is used to indicate the reception of a orphan notification command.
+     * See IEEE 802.15.4-2011, section 6.2.7.1
+     */
+    MlmeOrphanIndicationCallback m_mlmeOrphanIndicationCallback;
+
+    /**
      * This callback is used to report data transmission request status to the
      * upper layers.
      * See IEEE 802.15.4-2006, section 7.1.1.2.
@@ -2043,8 +2174,13 @@
     std::vector<uint8_t> m_energyDetectList;
 
     /**
+     * The list of unscanned channels during a scan operation.
+     */
+    std::vector<uint8_t> m_unscannedChannels;
+
+    /**
      * The parameters used during a MLME-SCAN.request. These parameters are stored here while
-     * PLME-SET operations (set channel page, set channel number) and multiple ed scans take place.
+     * PLME-SET (set channel page, set channel number) and other operations take place.
      */
     MlmeScanRequestParams m_scanParams;
 
@@ -2139,11 +2275,16 @@
     EventId m_trackingEvent;
 
     /**
-     * Scheduler event for the end of a channel scan.
+     * Scheduler event for the end of an ACTIVE or PASSIVE channel scan.
      */
     EventId m_scanEvent;
 
     /**
+     * Scheduler event for the end of an ORPHAN channel scan.
+     */
+    EventId m_scanOrphanEvent;
+
+    /**
      * Scheduler event for the end of a ED channel scan.
      */
     EventId m_scanEnergyEvent;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-mac-header.cc ns-3.39/src/lr-wpan/model/lr-wpan-mac-header.cc
--- ns-3.38/src/lr-wpan/model/lr-wpan-mac-header.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-mac-header.cc	2023-07-05 14:23:47.869427400 -0700
@@ -58,23 +58,19 @@
 {
 }
 
-enum LrWpanMacHeader::LrWpanMacType
+LrWpanMacHeader::LrWpanMacType
 LrWpanMacHeader::GetType() const
 {
     switch (m_fctrlFrmType)
     {
     case 0:
         return LRWPAN_MAC_BEACON;
-        break;
     case 1:
         return LRWPAN_MAC_DATA;
-        break;
     case 2:
         return LRWPAN_MAC_ACKNOWLEDGMENT;
-        break;
     case 3:
         return LRWPAN_MAC_COMMAND;
-        break;
     default:
         return LRWPAN_MAC_RESERVED;
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc ns-3.39/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc
--- ns-3.38/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2023-03-16 20:54:23.632868500 -0700
+++ ns-3.39/src/lr-wpan/model/lr-wpan-mac-pl-headers.cc	2023-07-05 14:23:47.869427400 -0700
@@ -182,6 +182,7 @@
     case BEACON_REQ:
         break;
     case COOR_REALIGN:
+        size += 8;
         break;
     case GTS_REQ:
         break;
@@ -217,6 +218,11 @@
     case BEACON_REQ:
         break;
     case COOR_REALIGN:
+        i.WriteU16(m_panid);
+        WriteTo(i, m_coordShortAddr);
+        i.WriteU8(m_logCh);
+        WriteTo(i, m_shortAddr);
+        i.WriteU8(m_logChPage);
         break;
     case GTS_REQ:
         break;
@@ -251,6 +257,11 @@
     case BEACON_REQ:
         break;
     case COOR_REALIGN:
+        m_panid = i.ReadU16();
+        ReadFrom(i, m_coordShortAddr);
+        m_logCh = i.ReadU8();
+        ReadFrom(i, m_shortAddr);
+        m_logChPage = i.ReadU8();
         break;
     case GTS_REQ:
         break;
@@ -264,7 +275,7 @@
 void
 CommandPayloadHeader::Print(std::ostream& os) const
 {
-    os << "| MAC Command Frame ID | = " << (uint32_t)m_cmdFrameId;
+    os << "| MAC Command Frame ID | = " << static_cast<uint32_t>(m_cmdFrameId);
     switch (m_cmdFrameId)
     {
     case ASSOCIATION_REQ:
@@ -289,6 +300,11 @@
     case BEACON_REQ:
         break;
     case COOR_REALIGN:
+        os << "| PAN identifier| = " << m_panid
+           << "| PAN Coord Short address| = " << m_coordShortAddr
+           << "| Channel Num.| = " << static_cast<uint32_t>(m_logCh)
+           << "| Short address| = " << m_shortAddr
+           << "| Page Num.| = " << static_cast<uint32_t>(m_logChPage);
         break;
     case GTS_REQ:
         break;
@@ -310,6 +326,34 @@
     m_capabilityInfo = cap;
 }
 
+void
+CommandPayloadHeader::SetCoordShortAddr(Mac16Address addr)
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    m_coordShortAddr = addr;
+}
+
+void
+CommandPayloadHeader::SetChannel(uint8_t channel)
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    m_logCh = channel;
+}
+
+void
+CommandPayloadHeader::SetPage(uint8_t page)
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    m_logChPage = page;
+}
+
+void
+CommandPayloadHeader::SetPanId(uint16_t id)
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    m_panid = id;
+}
+
 CommandPayloadHeader::MacCommand
 CommandPayloadHeader::GetCommandFrameType() const
 {
@@ -317,31 +361,22 @@
     {
     case 0x01:
         return ASSOCIATION_REQ;
-        break;
     case 0x02:
         return ASSOCIATION_RESP;
-        break;
     case 0x03:
         return DISASSOCIATION_NOTIF;
-        break;
     case 0x04:
         return DATA_REQ;
-        break;
     case 0x05:
         return PANID_CONFLICT;
-        break;
     case 0x06:
         return ORPHAN_NOTIF;
-        break;
     case 0x07:
         return BEACON_REQ;
-        break;
     case 0x08:
         return COOR_REALIGN;
-        break;
     case 0x09:
         return GTS_REQ;
-        break;
     default:
         return CMD_RESERVED;
     }
@@ -350,7 +385,7 @@
 void
 CommandPayloadHeader::SetShortAddr(Mac16Address shortAddr)
 {
-    NS_ASSERT(m_cmdFrameId == ASSOCIATION_RESP);
+    NS_ASSERT(m_cmdFrameId == ASSOCIATION_RESP || m_cmdFrameId == COOR_REALIGN);
     m_shortAddr = shortAddr;
 }
 
@@ -364,7 +399,6 @@
 Mac16Address
 CommandPayloadHeader::GetShortAddr() const
 {
-    NS_ASSERT(m_cmdFrameId == ASSOCIATION_RESP);
     return m_shortAddr;
 }
 
@@ -382,4 +416,32 @@
     return m_capabilityInfo;
 }
 
+Mac16Address
+CommandPayloadHeader::GetCoordShortAddr() const
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    return m_coordShortAddr;
+}
+
+uint8_t
+CommandPayloadHeader::GetChannel() const
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    return m_logCh;
+}
+
+uint8_t
+CommandPayloadHeader::GetPage() const
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    return m_logChPage;
+}
+
+uint16_t
+CommandPayloadHeader::GetPanId() const
+{
+    NS_ASSERT(m_cmdFrameId == COOR_REALIGN);
+    return m_panid;
+}
+
 } // namespace ns3
